function ds=fun_dsmCTm(W,Yct,R,Lag,Lmax,weight)
%
%  W:QxPxN, Yct:QxNT, R:PxQ, weight:Qx1
%
[Q,P,N]=size(W);
ds=0;
for p=1:P
    for q=1:Q
        xc=Yct(q,:)';
        y=squeeze(W(q,p,:));
        y=y(Lmax+1+Lag(p):N-Lmax+Lag(p));
        meanYct=mean(xc.^2);
        meany=mean(y.^2);
        if meanYct && meany>0
            sm=sqrt(max(0,mean((xc-R(p,q)*y).^2)))/R(p,q)/sqrt(meany);
        elseif meany >0
            sm=1;  
        elseif meanYct>0
            sm=sqrt(max(0,1-sum(xc)^2/sum(xc.^2)/length(xc)));  
        else
            sm=0;
        end
        ds=ds+weight(q)*sm;
    end
end